<template>
  <div class="container">
    <div>
      <gitlab-logo class="gitlab-logo" />
      <h1 class="title">
        Tanuki Inc
      </h1>
      <h2 class="subtitle">
        demo application
      </h2>
      <div class="links">
        <b-button variant="outline-primary" size="lg" @click="generateError">
          Generate Error
        </b-button>
        <b-button variant="outline-primary" size="lg" @click="generateLogs">
          Generate Logs
        </b-button>
      </div>
      <div class="links">
        <b-button
          href="https://gitlab.com/gitlab-examples/ops/incident-setup/everyone/tanuki-inc/-/error_tracking"
          size="md"
          target="_blank"
          variant="outline-secondary"
        >
          View Errors
        </b-button>
        <b-button
          href="https://gitlab.com/gitlab-examples/ops/incident-setup/everyone/tanuki-inc/-/logs"
          size="md"
          target="_blank"
          variant="outline-secondary"
        >
          View Logs
        </b-button>
      </div>
      <div class="links m-4">
        <a
          class="mx-2"
          href="https://gitlab.com/gitlab-examples/ops/incident-setup/everyone/tanuki-inc"
          target="_blank"
          >Repo</a
        >
        <a
          class="mx-2"
          href="https://gitlab.com/gitlab-examples/ops/incident-setup/everyone/tanuki-inc/-/metrics?environment=1118134"
          target="_blank"
          >Metrics</a
        >
        <a
          class="mx-2"
          href="https://sentry.gitlab.net/gitlab/tanuki-inc/"
          target="_blank"
          >Sentry</a
        >
      </div>
    </div>
  </div>
</template>

<script>
import { BButton } from 'bootstrap-vue'
import GitlabLogo from '@/assets/gitlab-logo.svg'
import GenerateLogs from '@/assets/javascript/generate_logs'

export default {
  components: {
    GitlabLogo,
    BButton
  },
  data() {
    return {
      // Generate random errors.
      errorIndex: Math.floor(Math.random() * 3),
      // Choose errors from list of 3 possibilities.
      errors: [
        new SyntaxError('Invalid or unexpected token'),
        new TypeError(`Cannot read property 'filter' of undefined`),
        new RangeError('The argument must be between 0 and 100.')
      ]
    }
  },
  methods: {
    generateError() {
      console.log('trigger generate error')
      this.$sentry.captureException(this.errors[this.errorIndex])
      // Cycle through errors as button is clicked.
      this.errorIndex = (this.errorIndex + 1) % 3
    },
    generateLogs: GenerateLogs
  }
}
</script>

<style>
.container {
  margin: 0 auto;
  min-height: 100vh;
  display: flex;
  justify-content: center;
  align-items: center;
  text-align: center;
}

.title {
  font-family: 'Quicksand', 'Source Sans Pro', -apple-system, BlinkMacSystemFont,
    'Segoe UI', Roboto, 'Helvetica Neue', Arial, sans-serif;
  display: block;
  font-weight: 250;
  font-size: 80px;
  color: #35495e;
  letter-spacing: 1px;
}

.subtitle {
  font-weight: 300;
  font-size: 42px;
  color: #526488;
  word-spacing: 5px;
  padding-bottom: 15px;
}

.links {
  padding-top: 15px;
}

.gitlab-logo {
  height: 300px;
  width: 300px;
}
</style>
